# Copyright (c) 2008, 2009 David Sugar, Tycho Softworks.
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.

Name: ucommon
Summary: Portable C++ runtime for threads and sockets
Version: 3.3.6
Release: 0%{?dist}
License: LGPLv3+
URL: http://www.gnu.org/software/commoncpp
Source0: http://www.gnutelephony.org/dist/tarballs/ucommon-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: doxygen graphviz-gd openssl-devel
Group: System Environment/Libraries
Summary: Runtime library for portable C++ threading and sockets

%description
GNU uCommon C++ is a lightweight library to facilitate using C++ design
patterns even for very deeply embedded applications, such as for systems using
uClibc along with POSIX threading support. For this reason, uCommon disables
language features that consume memory or introduce runtime overhead. uCommon
introduces some design patterns from Objective-C, such as reference counted
objects, memory pools, and smart pointers.  uCommon introduces some new
concepts for handling of thread locking and synchronization.

%package script
Requires: %{name} = %{version}-%{release}
Group: System Environment/Libraries
Summary: ucommon framework for script extensible applications

%package secure
Requires: %{name} = %{version}-%{release}
Requires: openssl
Group: System Environment/Libraries
Summary: ucommon framework for secure sockets and cryptography

%package audio
Requires: %{name} = %{version}-%{release}
Group: System Environment/Libraries
Summary: ucommon framework for telephonic audio support

%package bin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-audio = %{version}-%{release}
Group: Applications/System
Summary: ucommon system and support applications.

%package devel
Requires: %{name} = %{version}-%{release}
Requires: %{name}-secure = %{version}-%{release}
Requires: %{name}-script = %{version}-%{release}
Requires: %{name}-audio = %{version}-%{release}
Requires: %{name}-bin = %{version}-%{release}
Requires: pkgconfig
Group: Development/Libraries
Summary: Headers for building ucommon applications

%package doc
Group: Documentation
Summary: Generated class documentation for ucommon

%description script
GNU uCommon C++ script is a highly specialized embedded scripting engine and 
virtual execution environment for creating script "extensible" applications.  
This system is a C++ class library which allows one to derive application
specific dialects of the core language as needed through subclassing.

%description secure
The GNU uCommon C++ secure sockets and cryptography library offers thread-safe
ssl sockets for building clients and servers.  The crytographic library also
provides for random number generation, digest computation, and ciphering.

%description audio
The GNU uCommon C++ telephonic audio library covers a range of functionality 
including tone generation and detection, streaming and transcoding of encoded 
audio frames, accessing of audio files on disk, and phrasebook management.

%description bin
This is a collection of command line tools that use various aspects of the
ucommon library.  Some may be needed to prepare files or for development of
applications, such as audiotool, which might be used to prepare or convert
audio samples.

%description devel
This package provides header and support files needed for building 
applications that use the uCommon library and frameworks.

%description doc
Generated class documentation for GNU uCommon C++ framework
from header files, html browsable.

%prep
%setup -q
%build

%configure --disable-static
%{__make} %{?_smp_mflags}
%{__rm} -rf doc/html
%{__make} doxy

%install
%{__rm} -rf %{buildroot}
%{__make} DESTDIR=%{buildroot} INSTALL="install -p" install
%{__chmod} 0755 %{buildroot}%{_bindir}/ucommon-config
%{__rm} %{buildroot}%{_libdir}/*.la

%clean
%{__rm} -rf %{buildroot}

%files 
%defattr(-,root,root,-)
%doc AUTHORS README COPYING COPYING.LESSER COPYRIGHT NEWS SUPPORT ChangeLog
%{_libdir}/libucommon.so.*

%files secure
%defattr(-,root,root,-)
%{_libdir}/libuccsecure.so.*

%files script
%defattr(-,root,root,-)
%{_libdir}/libuccscript.so.*

%files audio
%defattr(-,root,root,-)
%{_libdir}/libuccaudio.so.*

%files bin
%defattr(-,root,root,-)
%{_bindir}/audiotool
%{_bindir}/args
%{_mandir}/man1/audiotool.*
%{_mandir}/man1/args.*

%files devel
%defattr(-,root,root,-)
%{_libdir}/*.so
%{_includedir}/ucommon/
%{_libdir}/pkgconfig/*.pc
%{_bindir}/ucommon-config
%{_mandir}/man1/ucommon-config.*

%files doc
%defattr(-,root,root,-)
%doc doc/html/*

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%changelog
* Sun Aug 01 2010 - David Sugar <dyfet@gnutelephony.org> - 3.3.0-0
- internationalization bindings with gnu gettext support.
- reorganized utils into ucommon-bin subpackage.

* Fri Jun 04 2010 - David Sugar <dyfet@gnutelephony.org> - 3.0.0-0
- merged ccscript and ccaudio with ucommon to create single framework.

* Sun Jul 19 2009 - David Sugar <dyfet@gnutelephony.org> - 2.0.6-1
- fixed ucommon-config upstream.

* Tue May 05 2009 - David Sugar <dyfet@gnutelephony.org> - 2.0.5-4
- removed static libraries, fixed other build issues (#498736)

* Sun May 03 2009 - David Sugar <dyfet@gnutelephony.org> - 2.0.5-3
- spec file prepared for redhat/fedora (#498736)

